------------------------------------------------------------------------------
--                                                                          --
--                         GNAT COMPILER COMPONENTS                         --
--                                                                          --
--                    S Y S T E M . V A L U E _ E N U M                     --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.2 $                              --
--                                                                          --
--           Copyright (c) 1992,1993,1994 NYU, All Rights Reserved          --
--                                                                          --
-- GNAT is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  GNAT is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with GNAT;  see file COPYING.  If not, write --
-- to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. --
--                                                                          --
------------------------------------------------------------------------------

function System.Value_Enum
  (A        : Address;
   Last_Pos : Natural;
   Str      : String)
   return     Natural;
--  Used in computing Enum'Value (Str) where Enum is some enumeration type
--  which is not Boolean or Character. A is the address of the Lit_Name_Table,
--  which is the table of access to strings, generated by Gigi for each
--  enumeration type. The table is an array whose index values are 'Pos values
--  and entries are access to string, where each string is the 'Image value.
--  Last_Pos is the last index in the table for the given enumeration type.
--  This function will search the table looking for a match against Str, and if
--  one is found the position number in the table is returned. Str may have
--  leading and trailing spaces and may be in upper or lower case.
